# Class VulkanApplicationInfo.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanApplicationInfo.Builder

Enclosing class:
  `VulkanApplicationInfo`

public static final class VulkanApplicationInfo.Builder extends Object
Builds instances of type `VulkanApplicationInfo`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanApplicationInfo`
  `build()`
  Builds a new `VulkanApplicationInfo`.
  `final VulkanApplicationInfo.Builder`
  `from(VulkanApplicationInfoType instance)`
  Fill a builder with attribute values from the provided `VulkanApplicationInfoType` instance.
  `final VulkanApplicationInfo.Builder`
  `setApplicationName(String applicationName)`
  Initializes the value for the `applicationName` attribute.
  `final VulkanApplicationInfo.Builder`
  `setApplicationVersion(int applicationVersion)`
  Initializes the value for the `applicationVersion` attribute.
  `final VulkanApplicationInfo.Builder`
  `setEngineName(String engineName)`
  Initializes the value for the `engineName` attribute.
  `final VulkanApplicationInfo.Builder`
  `setEngineVersion(int engineVersion)`
  Initializes the value for the `engineVersion` attribute.
  `final VulkanApplicationInfo.Builder`
  `setVulkanAPIVersion(int vulkanAPIVersion)`
  Initializes the value for the `vulkanAPIVersion` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanApplicationInfo.Builder from(VulkanApplicationInfoType instance)
    Fill a builder with attribute values from the provided `VulkanApplicationInfoType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setApplicationName

    public final VulkanApplicationInfo.Builder setApplicationName(String applicationName)
    Initializes the value for the `applicationName` attribute.
    Parameters:
      `applicationName` - The value for applicationName
    Returns:
      `this` builder for use in a chained invocation

  - ### setApplicationVersion

    public final VulkanApplicationInfo.Builder setApplicationVersion(int applicationVersion)
    Initializes the value for the `applicationVersion` attribute.
    Parameters:
      `applicationVersion` - The value for applicationVersion
    Returns:
      `this` builder for use in a chained invocation

  - ### setEngineName

    public final VulkanApplicationInfo.Builder setEngineName(String engineName)
    Initializes the value for the `engineName` attribute.
    Parameters:
      `engineName` - The value for engineName
    Returns:
      `this` builder for use in a chained invocation

  - ### setEngineVersion

    public final VulkanApplicationInfo.Builder setEngineVersion(int engineVersion)
    Initializes the value for the `engineVersion` attribute.
    Parameters:
      `engineVersion` - The value for engineVersion
    Returns:
      `this` builder for use in a chained invocation

  - ### setVulkanAPIVersion

    public final VulkanApplicationInfo.Builder setVulkanAPIVersion(int vulkanAPIVersion)
    Initializes the value for the `vulkanAPIVersion` attribute.
    Parameters:
      `vulkanAPIVersion` - The value for vulkanAPIVersion
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanApplicationInfo build()
    Builds a new `VulkanApplicationInfo`.
    Returns:
      An immutable instance of VulkanApplicationInfo
    Throws:
      `IllegalStateException` - if any required attributes are missing